module RailsViewComponent
  module Generators
    class InstallGenerator < Rails::Generators::Base

      source_root File.expand_path('../templates', __FILE__)
      def copy
        {
          "rails_view_component_builder.rb" => "lib/rails_view_component",
          "rails_view_component_helper.rb"  => "lib/rails_view_component",
          "rails_view_component_model.rb"   => "lib/rails_view_component",
          "RailsViewComponent.hx"           =>
                                        "lib/rails_view_component/haxe",
          "haxe_compile.hxml"               => "./",
        }.each{|file,dir|
          copy_file file, "#{dir}/#{file}"
        }
        
        inject_into_file "app/helpers/application_helper.rb",
            after: "module ApplicationHelper\n" do <<RUBY
        include RailsViewComponentHelper
RUBY
        end

        inject_into_file "config/application.rb",
            after: "class Application < Rails::Application\n" do <<RUBY
    config.autoload_paths += [
      "\#{config.root}/app/rails_view_components",
      "\#{config.root}/lib/rails_view_component",
    ]

RUBY
            end

      end
    
    end
  end
end
