class RailsViewComponentBuilder
  def initialize
    @count = 0
    @components = []
  end
  def destribute name, ajax_params = {}, erb_params={}
    namespace = name.to_s.camelize
    name = namespace.split("::").last
    @count += 1
    klass = Module.const_get("#{namespace}::#{name}Model")
    obj = klass.new @count
    @components.push obj
    obj.html(ajax_params, erb_params).html_safe
  end

  def all_javascripts
    @components.inject([]){|acc,c|acc + c.javascripts}.uniq
  end
  def all_stylesheets
    @components.inject([]){|acc,c|acc + c.stylesheets}.uniq
  end

  def refer_to_javascripts
    all_javascripts.map{|js|
      "<script type='text/javascript' src='#{js}'></script>" }.join
  end
  def refer_to_stylesheets
    all_stylesheets.map{|css|
      "<link rel='stylesheet' type='text/css' href='#{css}'>" }.join
  end


end
